## librdkafka 2.2.0

=== examples/CMakeLists.txt ===
if(WIN32)
    set(win32_sources ../win32/wingetopt.c ../win32/wingetopt.h)
endif(WIN32)

add_executable(producer producer.c ${win32_sources})
target_link_libraries(producer PUBLIC rdkafka)

add_executable(producer_cpp producer.cpp ${win32_sources})
target_link_libraries(producer_cpp PUBLIC rdkafka++)

add_executable(consumer consumer.c ${win32_sources})
target_link_libraries(consumer PUBLIC rdkafka)

add_executable(rdkafka_performance rdkafka_performance.c ${win32_sources})
target_link_libraries(rdkafka_performance PUBLIC rdkafka)

add_executable(rdkafka_example_cpp rdkafka_example.cpp ${win32_sources})
target_link_libraries(rdkafka_example_cpp PUBLIC rdkafka++)

add_executable(rdkafka_complex_consumer_example_cpp rdkafka_complex_consumer_example.cpp ${win32_sources})
target_link_libraries(rdkafka_complex_consumer_example_cpp PUBLIC rdkafka++)

add_executable(openssl_engine_example_cpp openssl_engine_example.cpp ${win32_sources})
target_link_libraries(openssl_engine_example_cpp PUBLIC rdkafka++)

add_executable(misc misc.c ${win32_sources})
target_link_libraries(misc PUBLIC rdkafka)

add_executable(idempotent_producer idempotent_producer.c ${win32_sources})
target_link_libraries(idempotent_producer PUBLIC rdkafka)

add_executable(transactions transactions.c ${win32_sources})
target_link_libraries(transactions PUBLIC rdkafka)

add_executable(delete_records delete_records.c ${win32_sources})
target_link_libraries(delete_records PUBLIC rdkafka)

add_executable(list_consumer_groups list_consumer_groups.c ${win32_sources})
target_link_libraries(list_consumer_groups PUBLIC rdkafka)

add_executable(describe_consumer_groups describe_consumer_groups.c ${win32_sources})
target_link_libraries(describe_consumer_groups PUBLIC rdkafka)

add_executable(list_consumer_group_offsets list_consumer_group_offsets.c ${win32_sources})
target_link_libraries(list_consumer_group_offsets PUBLIC rdkafka)

add_executable(alter_consumer_group_offsets alter_consumer_group_offsets.c ${win32_sources})
target_link_libraries(alter_consumer_group_offsets PUBLIC rdkafka)

add_executable(incremental_alter_configs incremental_alter_configs.c ${win32_sources})
target_link_libraries(incremental_alter_configs PUBLIC rdkafka)

add_executable(user_scram user_scram.c ${win32_sources})
target_link_libraries(user_scram PUBLIC rdkafka)

# The targets below has Unix include dirs and do not compile on Windows.
if(NOT WIN32)
    add_executable(rdkafka_example rdkafka_example.c)
    target_link_libraries(rdkafka_example PUBLIC rdkafka)

    add_executable(rdkafka_complex_consumer_example rdkafka_complex_consumer_example.c)
    target_link_libraries(rdkafka_complex_consumer_example PUBLIC rdkafka)

    add_executable(kafkatest_verifiable_client kafkatest_verifiable_client.cpp)
    target_link_libraries(kafkatest_verifiable_client PUBLIC rdkafka++)
endif(NOT WIN32)

=== examples/Makefile ===
EXAMPLES ?= rdkafka_example rdkafka_performance rdkafka_example_cpp \
	rdkafka_complex_consumer_example rdkafka_complex_consumer_example_cpp \
	kafkatest_verifiable_client \
	producer consumer idempotent_producer transactions \
	delete_records \
	openssl_engine_example_cpp \
	list_consumer_groups \
	describe_consumer_groups \
	list_consumer_group_offsets \
	alter_consumer_group_offsets \
	incremental_alter_configs \
	user_scram \
	misc

all: $(EXAMPLES)

include ../mklove/Makefile.base

CFLAGS += -I../src
CXXFLAGS += -I../src-cpp

# librdkafka must be compiled with -gstrict-dwarf, but rdkafka_example must not,
# due to some clang bug on OSX 10.9
CPPFLAGS := $(subst strict-dwarf,,$(CPPFLAGS))

rdkafka_example: ../src/librdkafka.a rdkafka_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./$@ -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

producer: ../src/librdkafka.a producer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

producer_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a producer.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) producer.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

consumer: ../src/librdkafka.a consumer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

idempotent_producer: ../src/librdkafka.a idempotent_producer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

transactions: ../src/librdkafka.a transactions.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

transactions-older-broker.c: ../src/librdkafka.a transactions-older-broker.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

delete_records: ../src/librdkafka.a delete_records.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

list_consumer_groups: ../src/librdkafka.a list_consumer_groups.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

describe_consumer_groups: ../src/librdkafka.a describe_consumer_groups.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

list_consumer_group_offsets: ../src/librdkafka.a list_consumer_group_offsets.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

alter_consumer_group_offsets: ../src/librdkafka.a alter_consumer_group_offsets.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

incremental_alter_configs: ../src/librdkafka.a incremental_alter_configs.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

rdkafka_complex_consumer_example: ../src/librdkafka.a rdkafka_complex_consumer_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_complex_consumer_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "./$@ <topic[:part]> <topic2[:part]> .."
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

rdkafka_performance: ../src/librdkafka.a rdkafka_performance.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_performance.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer"
	@echo "./$@ -P -t <topic> -p <partition> -s <msgsize>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"


rdkafka_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

kafkatest_verifiable_client: ../src-cpp/librdkafka++.a ../src/librdkafka.a kafkatest_verifiable_client.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) kafkatest_verifiable_client.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)


rdkafka_complex_consumer_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_complex_consumer_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_complex_consumer_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

rdkafka_consume_batch: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_consume_batch.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_consume_batch.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

openssl_engine_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a openssl_engine_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) openssl_engine_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS)

user_scram: ../src/librdkafka.a user_scram.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

misc: ../src/librdkafka.a misc.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

clean:
	rm -f $(EXAMPLES)

=== tests/CMakeLists.txt ===
set(
    sources
    0000-unittests.c
    0001-multiobj.c
    0002-unkpart.c
    0003-msgmaxsize.c
    0004-conf.c
    0005-order.c
    0006-symbols.c
    0007-autotopic.c
    0008-reqacks.c
    0009-mock_cluster.c
    0011-produce_batch.c
    0012-produce_consume.c
    0013-null-msgs.c
    0014-reconsume-191.c
    0015-offset_seeks.c
    0016-client_swname.c
    0017-compression.c
    0018-cgrp_term.c
    0019-list_groups.c
    0020-destroy_hang.c
    0021-rkt_destroy.c
    0022-consume_batch.c
    0025-timers.c
    0026-consume_pause.c
    0028-long_topicnames.c
    0029-assign_offset.c
    0030-offset_commit.c
    0031-get_offsets.c
    0033-regex_subscribe.c
    0034-offset_reset.c
    0035-api_version.c
    0036-partial_fetch.c
    0037-destroy_hang_local.c
    0038-performance.c
    0039-event.c
    0040-io_event.c
    0041-fetch_max_bytes.c
    0042-many_topics.c
    0043-no_connection.c
    0044-partition_cnt.c
    0045-subscribe_update.c
    0046-rkt_cache.c
    0047-partial_buf_tmout.c
    0048-partitioner.c
    0049-consume_conn_close.c
    0050-subscribe_adds.c
    0051-assign_adds.c
    0052-msg_timestamps.c
    0053-stats_cb.cpp
    0054-offset_time.cpp
    0055-producer_latency.c
    0056-balanced_group_mt.c
    0057-invalid_topic.cpp
    0058-log.cpp
    0059-bsearch.cpp
    0060-op_prio.cpp
    0061-consumer_lag.cpp
    0062-stats_event.c
    0063-clusterid.cpp
    0064-interceptors.c
    0065-yield.cpp
    0066-plugins.cpp
    0067-empty_topic.cpp
    0068-produce_timeout.c
    0069-consumer_add_parts.c
    0070-null_empty.cpp
    0072-headers_ut.c
    0073-headers.c
    0074-producev.c
    0075-retry.c
    0076-produce_retry.c
    0077-compaction.c
    0078-c_from_cpp.cpp
    0079-fork.c
    0080-admin_ut.c
    0081-admin.c
    0082-fetch_max_bytes.cpp
    0083-cb_event.c
    0084-destroy_flags.c
    0085-headers.cpp
    0086-purge.c
    0088-produce_metadata_timeout.c
    0089-max_poll_interval.c
    0090-idempotence.c
    0091-max_poll_interval_timeout.c
    0092-mixed_msgver.c
    0093-holb.c
    0094-idempotence_msg_timeout.c
    0095-all_brokers_down.cpp
    0097-ssl_verify.cpp
    0098-consumer-txn.cpp
    0099-commit_metadata.c
    0100-thread_interceptors.cpp
    0101-fetch-from-follower.cpp
    0102-static_group_rebalance.c
    0103-transactions.c
    0104-fetch_from_follower_mock.c
    0105-transactions_mock.c
    0106-cgrp_sess_timeout.c
    0107-topic_recreate.c
    0109-auto_create_topics.cpp
    0110-batch_size.cpp
    0111-delay_create_topics.cpp
    0112-assign_unknown_part.c
    0113-cooperative_rebalance.cpp
    0114-sticky_partitioning.cpp
    0115-producer_auth.cpp
    0116-kafkaconsumer_close.cpp
    0117-mock_errors.c
    0118-commit_rebalance.c
    0119-consumer_auth.cpp
    0120-asymmetric_subscription.c
    0121-clusterid.c
    0122-buffer_cleaning_after_rebalance.c
    0123-connections_max_idle.c
    0124-openssl_invalid_engine.c
    0125-immediate_flush.c
    0126-oauthbearer_oidc.c
    0127-fetch_queue_backoff.cpp
    0128-sasl_callback_queue.cpp
    0129-fetch_aborted_msgs.c
    0130-store_offsets.c
    0131-connect_timeout.c
    0132-strategy_ordering.c
    0133-ssl_keys.c
    0134-ssl_provider.c
    0135-sasl_credentials.cpp
    0136-resolve_cb.c
    0137-barrier_batch_consume.c
    0138-admin_mock.c
    0139-offset_validation_mock.c
    0140-commit_metadata.cpp
    0142-reauthentication.c
    8000-idle.cpp
    8001-fetch_from_follower_mock_manual.c
    test.c
    testcpp.cpp
    rusage.c
)

if(NOT WIN32)
    list(APPEND sources sockem.c sockem_ctrl.c)
else()
    list(APPEND sources ../src/tinycthread.c ../src/tinycthread_extra.c)
endif()

add_executable(test-runner ${sources})
target_link_libraries(test-runner PUBLIC rdkafka++)

add_test(NAME RdKafkaTestInParallel COMMAND test-runner -p5)
add_test(NAME RdKafkaTestSequentially COMMAND test-runner -p1)
add_test(NAME RdKafkaTestBrokerLess COMMAND test-runner -p5 -l)

if(NOT WIN32 AND NOT APPLE)
  set(tests_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  add_subdirectory(interceptor_test)
endif()

=== debian/changelog ===
librdkafka (2.2.0-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new (v2.1.0 and v2.2.0) symbols.
  * Update d/copyright with new copyright author for 2023.
  * Remove NEWS file with very old (2017) entries.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 14 Jul 2023 03:45:47 +0300

## librdkafka 2.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

include("packaging/cmake/parseversion.cmake")
parseversion("src/rdkafka.h")

project(RdKafka VERSION ${RDKAFKA_VERSION})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/packaging/cmake/Modules/")

# Options. No 'RDKAFKA_' prefix to match old C++ code. {

# This option doesn't affect build in fact, only C code
# (see 'rd_kafka_version_str'). In CMake the build type feature usually used
# (like Debug, Release, etc.).
option(WITHOUT_OPTIMIZATION "Disable optimization" OFF)

option(ENABLE_DEVEL "Enable development asserts, checks, etc" OFF)
option(ENABLE_REFCNT_DEBUG "Enable refcnt debugging" OFF)
set(TRYCOMPILE_SRC_DIR "${CMAKE_CURRENT_LIST_DIR}/packaging/cmake/try_compile")
set(BUILT_WITH "CMAKE")

# Toolchain {
list(APPEND BUILT_WITH "${CMAKE_C_COMPILER_ID}")
list(APPEND BUILT_WITH "${CMAKE_CXX_COMPILER_ID}")
# }

# PkgConfig {
find_package(PkgConfig QUIET)
if(PkgConfig_FOUND)
  set(WITH_PKGCONFIG ON)
  list(APPEND BUILT_WITH "PKGCONFIG")
endif()
# }

# LIBM {
include(CheckLibraryExists)
check_library_exists(m pow "" WITH_HDRHISTOGRAM)
if(WITH_HDRHISTOGRAM)
    list(APPEND BUILT_WITH "HDRHISTOGRAM")
endif()
# }

# ZLIB {
find_package(ZLIB QUIET)
if(ZLIB_FOUND)
  set(with_zlib_default ON)
else()
  set(with_zlib_default OFF)
endif()
option(WITH_ZLIB "With ZLIB" ${with_zlib_default})
if(WITH_ZLIB)
  list(APPEND BUILT_WITH "ZLIB")
endif()
# }

# CURL {
find_package(CURL QUIET)
if(CURL_FOUND)
  set(with_curl_default ON)
else()
  set(with_curl_default OFF)
endif()
option(WITH_CURL "With CURL" ${with_curl_default})
if(WITH_CURL)
  list(APPEND BUILT_WITH "CURL")
endif()
# }

# ZSTD {
find_package(ZSTD QUIET)
if(ZSTD_FOUND)
  set(with_zstd_default ON)
else()
  set(with_zstd_default OFF)
endif()
option(WITH_ZSTD "With ZSTD" ${with_zstd_default})
if(WITH_ZSTD)
  list(APPEND BUILT_WITH "ZSTD")
endif()
# }

# LibDL {
try_compile(
    WITH_LIBDL
    "${CMAKE_CURRENT_BINARY_DIR}/try_compile"
    "${TRYCOMPILE_SRC_DIR}/dlopen_test.c"
    LINK_LIBRARIES "${CMAKE_DL_LIBS}"
)
if(WITH_LIBDL)
  list(APPEND BUILT_WITH "LIBDL")
endif()
# }

# WITH_PLUGINS {
if(WITH_LIBDL OR WIN32)
  set(with_plugins_default ON)
else()
  set(with_plugins_default OFF)
endif()
option(WITH_PLUGINS "With plugin support" ${with_plugins_default})
if(WITH_PLUGINS)
  list(APPEND BUILT_WITH "PLUGINS")
endif()
# }

# OpenSSL {
if(WITH_BUNDLED_SSL) # option from 'h2o' parent project
  set(with_ssl_default ON)
else()
  find_package(OpenSSL QUIET)
  if(OpenSSL_FOUND)
    set(with_ssl_default ON)
  else()
    set(with_ssl_default OFF)
  endif()
endif()
option(WITH_SSL "With SSL" ${with_ssl_default})
if(WITH_SSL)
  list(APPEND BUILT_WITH "SSL")
endif()
# }

# SASL {
if(WIN32)
  set(with_sasl_default ON)
else()
  if(PkgConfig_FOUND)
    pkg_check_modules(SASL libsasl2)
    if(SASL_FOUND)
      set(with_sasl_default ON)
    else()
      try_compile(
          WITH_SASL_CYRUS_BOOL
          "${CMAKE_CURRENT_BINARY_DIR}/try_compile"
          "${TRYCOMPILE_SRC_DIR}/libsasl2_test.c"
          LINK_LIBRARIES "-lsasl2"
      )
      if(WITH_SASL_CYRUS_BOOL)
        set(with_sasl_default ON)
        set(SASL_LIBRARIES "-lsasl2")
      else()
        set(with_sasl_default OFF)
      endif()
    endif()
  endif()
endif()
option(WITH_SASL "With SASL" ${with_sasl_default})
if(WITH_SASL)
  if(SASL_FOUND)
    link_directories(${SASL_LIBRARY_DIRS})
  endif()
  if(WITH_SSL)
    set(WITH_SASL_SCRAM ON)
    set(WITH_SASL_OAUTHBEARER ON)
    list(APPEND BUILT_WITH "SASL_SCRAM SASL_OAUTHBEARER")
  endif()
  if(NOT WIN32)
    set(WITH_SASL_CYRUS ON)
    list(APPEND BUILT_WITH "SASL_CYRUS")
  endif()
endif()
# }

if(WITH_SSL AND WITH_CURL)
    set(WITH_OAUTHBEARER_OIDC ON)
endif()

# LZ4 {
option(ENABLE_LZ4_EXT "Enable external LZ4 library support" ON)
set(WITH_LZ4_EXT OFF)
if(ENABLE_LZ4_EXT)
  find_package(LZ4)
  if(LZ4_FOUND)
    set(WITH_LZ4_EXT ON)
    list(APPEND BUILT_WITH "LZ4_EXT")
  else()
    message(STATUS "Using bundled LZ4 implementation.")
  endif()
endif()
# }

option(RDKAFKA_BUILD_STATIC "Build static rdkafka library" OFF)
option(RDKAFKA_BUILD_EXAMPLES "Build examples" ON)
option(RDKAFKA_BUILD_TESTS "Build tests" ON)
if(WIN32)
    option(WITHOUT_WIN32_CONFIG "Avoid including win32_config.h on cmake builds" ON)
endif(WIN32)

# In:
# * TRYCOMPILE_SRC_DIR
# Out:
# * HAVE_ATOMICS_32
# * HAVE_ATOMICS_32_SYNC
# * HAVE_ATOMICS_64
# * HAVE_ATOMICS_64_SYNC
# * HAVE_REGEX
# * HAVE_STRNDUP
# * HAVE_PTHREAD_SETNAME_GNU
# * HAVE_PTHREAD_SETNAME_DARWIN
# * HAVE_PTHREAD_SETNAME_FREEBSD
# * WITH_C11THREADS
# * WITH_CRC32C_HW
# * LINK_ATOMIC
include("packaging/cmake/try_compile/rdkafka_setup.cmake")
if(WITH_C11THREADS)
  list(APPEND BUILT_WITH "C11THREADS")
endif()
if(WITH_CRC32C_HW)
  list(APPEND BUILT_WITH "CRC32C_HW")
endif()

set(GENERATED_DIR "${CMAKE_CURRENT_BINARY_DIR}/generated")

# In:
# * WITHOUT_OPTIMIZATION
# * ENABLE_DEVEL
# * ENABLE_REFCNT_DEBUG
# * HAVE_ATOMICS_32
# * HAVE_ATOMICS_32_SYNC
# * HAVE_ATOMICS_64
# * HAVE_ATOMICS_64_SYNC
# * WITH_ZLIB
# * WITH_SSL
# * WITH_SASL
# * HAVE_REGEX
# * HAVE_STRNDUP
# * HAVE_PTHREAD_SETNAME_GNU
# * HAVE_PTHREAD_SETNAME_DARWIN
# * HAVE_PTHREAD_SETNAME_FREEBSD
list(APPEND BUILT_WITH "SNAPPY")
list(APPEND BUILT_WITH "SOCKEM")
string(REPLACE ";" " " BUILT_WITH "${BUILT_WITH}")
configure_file("packaging/cmake/config.h.in" "${GENERATED_DIR}/config.h")

# Installation (https://github.com/forexample/package-example) {

include(GNUInstallDirs)

set(config_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")

set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(project_version "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)

# In:
#   * targets_export_name
#   * PROJECT_NAME
configure_package_config_file(
    "packaging/cmake/Config.cmake.in"
    "${project_config}"
    INSTALL_DESTINATION "${config_install_dir}"
)

write_basic_package_version_file(
    "${project_version}"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(
    FILES "${project_config}" "${project_version}" "packaging/cmake/Modules/FindLZ4.cmake"
    DESTINATION "${config_install_dir}"
)

install(
    EXPORT "${targets_export_name}"
    NAMESPACE "${namespace}"
    DESTINATION "${config_install_dir}"
)

install(
    FILES LICENSES.txt
    DESTINATION "share/licenses/librdkafka"
)

add_subdirectory(src)
add_subdirectory(src-cpp)

if(RDKAFKA_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

if(RDKAFKA_BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

=== Makefile ===
LIBSUBDIRS=	src src-cpp

CHECK_FILES+=	CONFIGURATION.md \
		examples/rdkafka_example examples/rdkafka_performance \
		examples/rdkafka_example_cpp

DOC_FILES+=	LICENSE LICENSES.txt INTRODUCTION.md README.md \
		CONFIGURATION.md STATISTICS.md CHANGELOG.md

PKGNAME?=	librdkafka
VERSION?=	$(shell python3 packaging/get_version.py src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER ?= 1

# Skip copyright check in the following paths
MKL_COPYRIGHT_SKIP?=^(tests|packaging)


.PHONY:

all: mklove-check libs CONFIGURATION.md check TAGS

include mklove/Makefile.base

libs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d || exit $?; done)

CONFIGURATION.md: src/rdkafka.h examples
	@printf "$(MKL_YELLOW)Updating $@$(MKL_CLR_RESET)\n"
	@echo "# Configuration properties" > CONFIGURATION.md.tmp
	@(examples/rdkafka_performance -X list | \
		sed 's/||/\\|\\|/g' >> \
		CONFIGURATION.md.tmp; \
		cmp CONFIGURATION.md CONFIGURATION.md.tmp || \
		mv -f CONFIGURATION.md.tmp CONFIGURATION.md; \
		rm -f CONFIGURATION.md.tmp)

file-check: CONFIGURATION.md LICENSES.txt examples
check: file-check
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

install-subdirs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d install || exit $?; done)

install: install-subdirs doc-install

uninstall-subdirs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d uninstall || exit $?; done)

uninstall: uninstall-subdirs doc-uninstall

examples tests: .PHONY libs
	$(MAKE) -C $@

docs:
	doxygen Doxyfile
	@echo "Documentation generated in staging-docs"

clean-docs:
	rm -rf staging-docs

clean:
	@$(MAKE) -C tests $@
	@$(MAKE) -C examples $@
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ ; done)

distclean: clean deps-clean
	./configure --clean
	rm -f config.log config.log.old

archive:
	git archive --prefix=$(PKGNAME)-$(VERSION)/ \
		-o $(PKGNAME)-$(VERSION).tar.gz HEAD
	git archive --prefix=$(PKGNAME)-$(VERSION)/ \
		-o $(PKGNAME)-$(VERSION).zip HEAD

rpm: distclean
	$(MAKE) -C packaging/rpm

LICENSES.txt: .PHONY
	@(for i in LICENSE LICENSE.*[^~] ; do (echo "$$i" ; echo "--------------------------------------------------------------" ; cat $$i ; echo "" ; echo "") ; done) > $@.tmp
	@cmp $@ $@.tmp || mv -f $@.tmp $@ ; rm -f $@.tmp


TAGS: .PHONY
	@(if which etags >/dev/null 2>&1 ; then \
		echo "Using etags to generate $@" ; \
		git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h)$$' | \
			etags -f $@.tmp - ; \
		cmp $@ $@.tmp || mv $@.tmp $@ ; rm -f $@.tmp ; \
	 elif which ctags >/dev/null 2>&1 ; then \
		echo "Using ctags to generate $@" ; \
		git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h)$$' | \
			ctags -e -f $@.tmp -L- ; \
		cmp $@ $@.tmp || mv $@.tmp $@ ; rm -f $@.tmp ; \
	fi)

coverity: Makefile.config
	@(which cov-build >/dev/null 2>&1 || echo "Make sure coverity../bin is in your PATH")
	@(cd src && \
	 make clean && \
	 (rm -rf cov-int cov-librdkafka.tgz cov-build || true) && \
	 cov-build --dir cov-int make -j && \
	 tar cvzf ../cov-librdkafka.tgz cov-int && \
	 printf "$(MKL_GREEN)Now upload cov-librdkafka.tgz to Coverity for analysis$(MKL_CLR_RESET)\n")


style-check:
	@(packaging/tools/style-format.sh \
		$$(git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h|py)$$') )

style-check-changed:
	@(packaging/tools/style-format.sh \
		$$( (git diff --name-only ; git diff --name-only --staged) | egrep '\.(c|cpp|h|py)$$'))

style-fix:
	@(packaging/tools/style-format.sh --fix \
		$$(git ls-tree -r --name-only HEAD | egrep '\.(c|cpp|h|py)$$'))

style-fix-changed:
	@(packaging/tools/style-format.sh --fix \
		$$( (git diff --name-only ; git diff --name-only --staged) | egrep '\.(c|cpp|h|py)$$'))

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,15 @@
 add_executable(user_scram user_scram.c ${win32_sources})
 target_link_libraries(user_scram PUBLIC rdkafka)
 
+add_executable(describe_topics describe_topics.c ${win32_sources})
+target_link_libraries(describe_topics PUBLIC rdkafka)
+
+add_executable(describe_cluster describe_cluster.c ${win32_sources})
+target_link_libraries(describe_cluster PUBLIC rdkafka)
+
+add_executable(list_offsets list_offsets.c ${win32_sources})
+target_link_libraries(list_offsets PUBLIC rdkafka)
+
 # The targets below has Unix include dirs and do not compile on Windows.
 if(NOT WIN32)
     add_executable(rdkafka_example rdkafka_example.c)
@@ -63,4 +72,5 @@
 
     add_executable(kafkatest_verifiable_client kafkatest_verifiable_client.cpp)
     target_link_libraries(kafkatest_verifiable_client PUBLIC rdkafka++)
+
 endif(NOT WIN32)

=== examples/Makefile ===
--- 
+++ 
@@ -6,10 +6,13 @@
 	openssl_engine_example_cpp \
 	list_consumer_groups \
 	describe_consumer_groups \
+	describe_topics \
+	describe_cluster \
 	list_consumer_group_offsets \
 	alter_consumer_group_offsets \
 	incremental_alter_configs \
 	user_scram \
+	list_offsets \
 	misc
 
 all: $(EXAMPLES)
@@ -71,6 +74,14 @@
 		../src/librdkafka.a $(LIBS)
 
 describe_consumer_groups: ../src/librdkafka.a describe_consumer_groups.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
+		../src/librdkafka.a $(LIBS)
+
+describe_topics: ../src/librdkafka.a describe_topics.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
+		../src/librdkafka.a $(LIBS)
+
+describe_cluster: ../src/librdkafka.a describe_cluster.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
 		../src/librdkafka.a $(LIBS)
 
@@ -138,6 +149,10 @@
 	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
 		../src/librdkafka.a $(LIBS)
 
+list_offsets: ../src/librdkafka.a list_offsets.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
+		../src/librdkafka.a $(LIBS)
+
 misc: ../src/librdkafka.a misc.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
 		../src/librdkafka.a $(LIBS)

=== src/CMakeLists.txt ===
set(LIBVER 1)

set(
    sources
    crc32c.c
    rdaddr.c
    rdavl.c
    rdbuf.c
    rdcrc32.c
    rdfnv1a.c
    rdbase64.c
    rdkafka.c
    rdkafka_assignor.c
    rdkafka_broker.c
    rdkafka_buf.c
    rdkafka_cgrp.c
    rdkafka_conf.c
    rdkafka_event.c
    rdkafka_feature.c
    rdkafka_lz4.c
    rdkafka_metadata.c
    rdkafka_metadata_cache.c
    rdkafka_msg.c
    rdkafka_msgset_reader.c
    rdkafka_msgset_writer.c
    rdkafka_offset.c
    rdkafka_op.c
    rdkafka_partition.c
    rdkafka_pattern.c
    rdkafka_queue.c
    rdkafka_range_assignor.c
    rdkafka_request.c
    rdkafka_roundrobin_assignor.c
    rdkafka_sasl.c
    rdkafka_sasl_plain.c
    rdkafka_sticky_assignor.c
    rdkafka_subscription.c
    rdkafka_assignment.c
    rdkafka_timer.c
    rdkafka_topic.c
    rdkafka_transport.c
    rdkafka_interceptor.c
    rdkafka_header.c
    rdkafka_admin.c
    rdkafka_aux.c
    rdkafka_background.c
    rdkafka_idempotence.c
    rdkafka_txnmgr.c
    rdkafka_cert.c
    rdkafka_coord.c
    rdkafka_mock.c
    rdkafka_mock_handlers.c
    rdkafka_mock_cgrp.c
    rdkafka_error.c
    rdkafka_fetcher.c
    rdlist.c
    rdlog.c
    rdmurmur2.c
    rdports.c
    rdrand.c
    rdregex.c
    rdstring.c
    rdunittest.c
    rdvarint.c
    rdmap.c
    snappy.c
    tinycthread.c
    tinycthread_extra.c
    rdxxhash.c
    cJSON.c
)

if(WITH_SSL)
  list(APPEND sources rdkafka_ssl.c)
endif()

if(WITH_CURL)
 list(APPEND sources rdhttp.c)
endif()

if(WITH_HDRHISTOGRAM)
  list(APPEND sources rdhdrhistogram.c)
endif()

if(WITH_LIBDL OR WIN32)
  list(APPEND sources rddl.c)
endif()

if(WITH_PLUGINS)
  list(APPEND sources rdkafka_plugin.c)
endif()

if(WIN32)
  list(APPEND sources rdkafka_sasl_win32.c)
elseif(WITH_SASL_CYRUS)
  list(APPEND sources rdkafka_sasl_cyrus.c)
endif()

if(WITH_SASL_SCRAM)
  list(APPEND sources rdkafka_sasl_scram.c)
endif()

if(WITH_SASL_OAUTHBEARER)
  list(APPEND sources rdkafka_sasl_oauthbearer.c)
endif()

if(WITH_OAUTHBEARER_OIDC)
  list(APPEND sources rdkafka_sasl_oauthbearer_oidc.c)
endif()

if(WITH_ZLIB)
  list(APPEND sources rdgz.c)
endif()

if(WITH_ZSTD)
  list(APPEND sources rdkafka_zstd.c)
endif()

if(NOT WITH_LZ4_EXT)
  list(APPEND sources lz4.c lz4frame.c lz4hc.c)
endif()

if(NOT HAVE_REGEX)
  list(APPEND sources regexp.c)
endif()

# Define flags with cmake instead of by defining them on win32_config.h
if(WITHOUT_WIN32_CONFIG)
  list(APPEND rdkafka_compile_definitions WITHOUT_WIN32_CONFIG)
  if(WITH_SSL)
    list(APPEND rdkafka_compile_definitions WITH_SSL=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_SSL=0)
  endif(WITH_SSL)
  if(WITH_ZLIB)
    list(APPEND rdkafka_compile_definitions WITH_ZLIB=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_ZLIB=0)
  endif(WITH_ZLIB)
  if(WITH_SNAPPY)
    list(APPEND rdkafka_compile_definitions WITH_SNAPPY=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_SNAPPY=0)
  endif(WITH_SNAPPY)
  if(WITH_ZSTD)
    list(APPEND rdkafka_compile_definitions WITH_ZSTD=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_ZSTD=0)
  endif(WITH_ZSTD)
  if(WITH_SASL_SCRAM)
    list(APPEND rdkafka_compile_definitions WITH_SASL_SCRAM=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_SASL_SCRAM=0)
  endif(WITH_SASL_SCRAM)
  if(WITH_SASL_OAUTHBEARER)
    list(APPEND rdkafka_compile_definitions WITH_SASL_OAUTHBEARER=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_SASL_OAUTHBEARER=0)
  endif(WITH_SASL_OAUTHBEARER)
  if(ENABLE_DEVEL)
    list(APPEND rdkafka_compile_definitions ENABLE_DEVEL=1)
  else()
    list(APPEND rdkafka_compile_definitions ENABLE_DEVEL=0)
  endif(ENABLE_DEVEL)
  if(WITH_PLUGINS)
    list(APPEND rdkafka_compile_definitions WITH_PLUGINS=1)
  else()
    list(APPEND rdkafka_compile_definitions WITH_PLUGINS=0)
  endif(WITH_PLUGINS)
endif()

if(RDKAFKA_BUILD_STATIC)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  set(RDKAFKA_BUILD_MODE STATIC)
else()
  set(RDKAFKA_BUILD_MODE SHARED)
endif()

add_library(rdkafka ${RDKAFKA_BUILD_MODE} ${sources})
if(NOT RDKAFKA_BUILD_STATIC)
  set_property(TARGET rdkafka PROPERTY SOVERSION ${LIBVER})
endif()

if(MINGW)
  # Target Windows 8.1 to match the VS projects (MinGW defaults to an older WinAPI version)
  list(APPEND rdkafka_compile_definitions WINVER=0x0603 _WIN32_WINNT=0x0603 UNICODE)
endif(MINGW)

# Support '#include <rdkafka.h>'
target_include_directories(rdkafka PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}> $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_compile_definitions(rdkafka PUBLIC ${rdkafka_compile_definitions})
if(RDKAFKA_BUILD_STATIC)
  target_compile_definitions(rdkafka PUBLIC LIBRDKAFKA_STATICLIB)
endif()

# We need 'dummy' directory to support `#include "../config.h"` path
set(dummy "${GENERATED_DIR}/dummy")
file(MAKE_DIRECTORY "${dummy}")
target_include_directories(rdkafka PUBLIC "$<BUILD_INTERFACE:${dummy}>")

if(WITH_CURL)
  find_package(CURL REQUIRED)
  target_include_directories(rdkafka PRIVATE ${CURL_INCLUDE_DIRS})
  target_link_libraries(rdkafka PUBLIC ${CURL_LIBRARIES})
endif()

if(WITH_HDRHISTOGRAM)
  target_link_libraries(rdkafka PUBLIC m)
endif()

if(WITH_ZLIB)
  find_package(ZLIB REQUIRED)
  target_include_directories(rdkafka PRIVATE ${ZLIB_INCLUDE_DIRS})
  target_link_libraries(rdkafka PUBLIC ZLIB::ZLIB)
endif()

if(WITH_ZSTD)
  target_link_libraries(rdkafka PRIVATE ${ZSTD_LIBRARY})
  target_include_directories(rdkafka PRIVATE ${ZSTD_INCLUDE_DIR})
  message(STATUS "Found ZSTD: ${ZSTD_LIBRARY}")
endif()

if(WITH_SSL)
  if(WITH_BUNDLED_SSL) # option from 'h2o' parent project
    if(NOT TARGET bundled-ssl)
      message(FATAL_ERROR "bundled-ssl target not exist")
    endif()
    target_include_directories(rdkafka BEFORE PRIVATE ${BUNDLED_SSL_INCLUDE_DIR})
    target_link_libraries(rdkafka PUBLIC ${BUNDLED_SSL_LIBRARIES})
    add_dependencies(rdkafka bundled-ssl)
  else()
    find_package(OpenSSL REQUIRED)
    target_include_directories(rdkafka PRIVATE ${OPENSSL_INCLUDE_DIR})
    target_link_libraries(rdkafka PUBLIC OpenSSL::SSL OpenSSL::Crypto)
    get_target_property(OPENSSL_TARGET_TYPE OpenSSL::SSL TYPE)
    if(OPENSSL_CRYPTO_LIBRARY MATCHES "\\.a$")
      target_compile_definitions(rdkafka PUBLIC WITH_STATIC_LIB_libcrypto)
    endif()
  endif()
endif()

if(LINK_ATOMIC)
  target_link_libraries(rdkafka PUBLIC "-latomic")
endif()

find_package(Threads REQUIRED)
target_link_libraries(rdkafka PUBLIC Threads::Threads)

if(WITH_SASL_CYRUS)
  target_include_directories(rdkafka PRIVATE ${SASL_INCLUDE_DIRS})
  target_link_libraries(rdkafka PUBLIC ${SASL_LIBRARIES})
endif()

if(WITH_LIBDL)
  target_link_libraries(rdkafka PUBLIC ${CMAKE_DL_LIBS})
endif()

if(WITH_LZ4_EXT)
  target_include_directories(rdkafka PRIVATE ${LZ4_INCLUDE_DIRS})
  target_link_libraries(rdkafka PUBLIC LZ4::LZ4)
endif()

if(WIN32)
  if(WITH_SSL)
    target_link_libraries(rdkafka PUBLIC crypt32)
  endif()

  target_link_libraries(rdkafka PUBLIC ws2_32 secur32)
  if(NOT RDKAFKA_BUILD_STATIC)
    target_compile_definitions(rdkafka PRIVATE LIBRDKAFKA_EXPORTS)
  endif()
endif()

# Generate pkg-config file
set(PKG_CONFIG_VERSION "${PROJECT_VERSION}")
set(PKG_CONFIG_REQUIRES_PRIVATE "")
if (WIN32)
  set(PKG_CONFIG_LIBS_PRIVATE "-lws2_32 -lsecur32 -lcrypt32")
else()
  set(PKG_CONFIG_LIBS_PRIVATE "-lpthread")
  find_library(RT_LIBRARY rt)
  if(RT_LIBRARY)
    string(APPEND PKG_CONFIG_LIBS_PRIVATE " -lrt")
  endif()

  if(WITH_LIBDL)
    string(APPEND PKG_CONFIG_LIBS_PRIVATE " -ldl")
  endif()

  if(WITH_HDRHISTOGRAM)
    string(APPEND PKG_CONFIG_LIBS_PRIVATE " -lm")
  endif()
endif()

if(NOT RDKAFKA_BUILD_STATIC)
  set(PKG_CONFIG_NAME "librdkafka")
  set(PKG_CONFIG_DESCRIPTION "The Apache Kafka C/C++ library")

  if(WITH_CURL)
    string(APPEND PKG_CONFIG_REQUIRES_PRIVATE "libcurl ")
  endif()

  if(WITH_ZLIB)
    string(APPEND PKG_CONFIG_REQUIRES_PRIVATE "zlib ")
  endif()

  if(WITH_SSL)
    string(APPEND PKG_CONFIG_REQUIRES_PRIVATE "libcrypto libssl ")
  endif()

  if(WITH_SASL_CYRUS)
    string(APPEND PKG_CONFIG_REQUIRES_PRIVATE "libsasl2 ")
  endif()

  if(WITH_ZSTD)
    string(APPEND PKG_CONFIG_REQUIRES_PRIVATE "libzstd ")
  endif()

  if(WITH_LZ4_EXT)
    string(APPEND PKG_CONFIG_REQUIRES_PRIVATE "liblz4 ")
  endif()

  set(PKG_CONFIG_CFLAGS "-I\${includedir}")
  set(PKG_CONFIG_LIBS "-L\${libdir} -lrdkafka")

  configure_file(
    "../packaging/cmake/rdkafka.pc.in"
    "${GENERATED_DIR}/rdkafka.pc"
    @ONLY
  )
  install(
    FILES ${GENERATED_DIR}/rdkafka.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
  )
else()
  set(PKG_CONFIG_NAME "librdkafka-static")
  set(PKG_CONFIG_DESCRIPTION "The Apache Kafka C/C++ library (static)")
  set(PKG_CONFIG_CFLAGS "-I\${includedir} -DLIBRDKAFKA_STATICLIB")
  set(PKG_CONFIG_LIBS "-L\${libdir} \${libdir}/librdkafka.a")
  string(APPEND PKG_CONFIG_LIBS " ${PKG_CONFIG_LIBS_PRIVATE}")
  set(PKG_CONFIG_LIBS_PRIVATE "")
  configure_file(
    "../packaging/cmake/rdkafka.pc.in"
    "${GENERATED_DIR}/rdkafka-static.pc"
    @ONLY
  )
  install(
    FILES ${GENERATED_DIR}/rdkafka-static.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
  )
endif()

install(
    TARGETS rdkafka
    EXPORT "${targets_export_name}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    FILES "rdkafka.h" "rdkafka_mock.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/librdkafka"
)

=== src/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka
LIBVER=		1

-include ../Makefile.config

ifneq ($(wildcard ../.git),)
# Add librdkafka version string from git tag if this is a git checkout
CPPFLAGS += -DLIBRDKAFKA_GIT_VERSION="\"$(shell git describe --abbrev=6 --dirty --tags 2>/dev/null)\""
endif

SRCS_$(WITH_SASL_CYRUS) += rdkafka_sasl_cyrus.c
SRCS_$(WITH_SASL_SCRAM) += rdkafka_sasl_scram.c
SRCS_$(WITH_SASL_OAUTHBEARER) += rdkafka_sasl_oauthbearer.c
SRCS_$(WITH_SNAPPY) += snappy.c
SRCS_$(WITH_ZLIB) += rdgz.c
SRCS_$(WITH_ZSTD) += rdkafka_zstd.c
SRCS_$(WITH_HDRHISTOGRAM) += rdhdrhistogram.c
SRCS_$(WITH_SSL) += rdkafka_ssl.c
SRCS_$(WITH_CURL) += rdhttp.c
SRCS_$(WITH_OAUTHBEARER_OIDC) += rdkafka_sasl_oauthbearer_oidc.c

SRCS_LZ4 = rdxxhash.c
ifneq ($(WITH_LZ4_EXT), y)
# Use built-in liblz4
SRCS_LZ4 += lz4.c lz4frame.c lz4hc.c
endif
SRCS_y += rdkafka_lz4.c $(SRCS_LZ4)

SRCS_$(WITH_LIBDL) += rddl.c
SRCS_$(WITH_PLUGINS) += rdkafka_plugin.c

ifneq ($(HAVE_REGEX), y)
SRCS_y += regexp.c
endif

SRCS=		rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
		rdkafka_conf.c rdkafka_timer.c rdkafka_offset.c \
		rdkafka_transport.c rdkafka_buf.c rdkafka_queue.c rdkafka_op.c \
		rdkafka_request.c rdkafka_cgrp.c rdkafka_pattern.c \
		rdkafka_partition.c rdkafka_subscription.c \
		rdkafka_assignment.c \
		rdkafka_assignor.c rdkafka_range_assignor.c \
		rdkafka_roundrobin_assignor.c rdkafka_sticky_assignor.c \
		rdkafka_feature.c \
		rdcrc32.c crc32c.c rdmurmur2.c rdfnv1a.c cJSON.c \
		rdaddr.c rdrand.c rdlist.c \
		tinycthread.c tinycthread_extra.c \
		rdlog.c rdstring.c rdkafka_event.c rdkafka_metadata.c \
		rdregex.c rdports.c rdkafka_metadata_cache.c rdavl.c \
		rdkafka_sasl.c rdkafka_sasl_plain.c rdkafka_interceptor.c \
		rdkafka_msgset_writer.c rdkafka_msgset_reader.c \
		rdkafka_header.c rdkafka_admin.c rdkafka_aux.c \
		rdkafka_background.c rdkafka_idempotence.c rdkafka_cert.c \
		rdkafka_txnmgr.c rdkafka_coord.c rdbase64.c \
		rdvarint.c rdbuf.c rdmap.c rdunittest.c \
		rdkafka_mock.c rdkafka_mock_handlers.c rdkafka_mock_cgrp.c \
		rdkafka_error.c rdkafka_fetcher.c \
		$(SRCS_y)

HDRS=		rdkafka.h rdkafka_mock.h

OBJS=		$(SRCS:.c=.o)


all: lib check

include ../mklove/Makefile.base

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a

file-check: lib
check: file-check
	@(printf "%-30s " "Symbol visibility" ; \
		(($(SYMDUMPER) $(LIBFILENAME) | grep rd_kafka_new >/dev/null) && \
		($(SYMDUMPER) $(LIBFILENAME) | grep -v rd_kafka_destroy >/dev/null) && \
		printf "$(MKL_GREEN)OK$(MKL_CLR_RESET)\n") || \
		printf "$(MKL_RED)FAILED$(MKL_CLR_RESET)\n")

install: lib-install
uninstall: lib-uninstall

clean: lib-clean

# Compile LZ4 with -O3
$(SRCS_LZ4:.c=.o): CFLAGS:=$(CFLAGS) -O3

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME_LDS)

$(LIBNAME_LDS): $(HDRS)
	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
	  cat $(HDRS) | ../lds-gen.py > $@)
endif

-include $(DEPS)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -133,6 +133,8 @@
     0139-offset_validation_mock.c
     0140-commit_metadata.cpp
     0142-reauthentication.c
+    0143-exponential_backoff_mock.c
+    0144-idempotence_mock.c
     8000-idle.cpp
     8001-fetch_from_follower_mock_manual.c
     test.c

=== packaging/nuget/requirements.txt ===
boto3==1.18.45
rpmfile==1.0.8
filemagic==1.6

=== tests/fixtures/ssl/Makefile ===
ssl_keys: clear_keys
	@./create_keys.sh client client2

clear_keys:
	@rm -f *.key *.crt *.jks \
	*.csr *.pem *.p12 *.srl extfile

.PHONY: ssl_keys

=== debian/changelog ===
librdkafka (2.3.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:32:46 +0000

librdkafka (2.3.0-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:27:25 +0000

librdkafka (2.3.0-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new symbols.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 27 Oct 2023 17:10:33 +0300

=== debian/control ===
Source: librdkafka
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
Uploaders:
 Christos Trochalakis <ctrochalakis@debian.org>,
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 liblz4-dev,
 libsasl2-dev,
 libssl-dev,
 libzstd-dev,
 python3,
 rapidjson-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/confluentinc/librdkafka
Vcs-Git: https://salsa.debian.org/kafka-team/librdkafka.git
Vcs-Browser: https://salsa.debian.org/kafka-team/librdkafka

Package: librdkafka1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing the Apache Kafka protocol
 librdkafka is a C library implementation of the Apache Kafka protocol,
 providing Producer, Consumer and Admin clients. It was designed with message
 delivery reliability and high performance in mind, current figures exceed 1
 million msgs/second for the producer and 3 million msgs/second for the
 consumer.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C shared library.

Package: librdkafka++1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing the Apache Kafka protocol (C++ bindings)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 providing Producer, Consumer and Admin clients. It was designed with message
 delivery reliability and high performance in mind, current figures exceed 1
 million msgs/second for the producer and 3 million msgs/second for the
 consumer.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C++ shared library.

Package: librdkafka-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 librdkafka++1 (= ${binary:Version}),
 librdkafka1 (= ${binary:Version}),
 ${misc:Depends}
Description: library implementing the Apache Kafka protocol (development headers)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 providing Producer, Consumer and Admin clients. It was designed with message
 delivery reliability and high performance in mind, current figures exceed 1
 million msgs/second for the producer and 3 million msgs/second for the
 consumer.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_EXPORT_BUILDFLAGS=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

include /usr/share/dpkg/buildflags.mk

%:
	dh $@

## librdkafka 2.4.0

=== debian/changelog ===
librdkafka (2.4.0-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new symbols.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 21 May 2024 16:53:19 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: librdkafka
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
+Maintainer: Faidon Liambotis <paravoid@debian.org>
 Uploaders:
  Christos Trochalakis <ctrochalakis@debian.org>,
  ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
@@ -14,7 +13,7 @@
  python3,
  rapidjson-dev,
  zlib1g-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/confluentinc/librdkafka

## librdkafka 2.5.0

=== debian/changelog ===
librdkafka (2.5.0-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new symbols.
  * Build-Depend on libcurl4-openssl-dev, required for SASL OAUTHBEARER OIDC
    support.
  * Build-Depend on pkgconf, which results in build-dependent libraries to be
    listed in Requires.private (instead of Libs.private) in the shipped .pc.
  * Add all (necessary) Build-Depends as Depends of the -dev package. They
    were already required for static linking, but are now required for shared
    linking as well, when "pkgconf --cflags" is being used.
  * Use "pkgconf" instead of the deprecated "pkg-config" in autopkgtests.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 13 Aug 2024 14:53:59 +0300

## librdkafka 2.6.0

=== debian/changelog ===
librdkafka (2.6.0-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new symbols.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 12 Oct 2024 12:07:11 +0300

librdkafka (2.5.3-1) unstable; urgency=medium

  * New upstream release.

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 02 Sep 2024 12:43:19 +0300
